'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _pathHelpers = require('../helpers/pathHelpers');

var _CheckboxInput = require('../../styles/cspace-input/CheckboxInput.css');

var _CheckboxInput2 = _interopRequireDefault(_CheckboxInput);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

const propTypes = {
  className: _propTypes2.default.string,
  embedded: _propTypes2.default.bool,
  /* eslint-disable react/no-unused-prop-types */
  name: _propTypes2.default.string,
  parentPath: _pathHelpers.pathPropType,
  subpath: _pathHelpers.pathPropType,
  /* eslint-enable react/no-unused-prop-types */
  readOnly: _propTypes2.default.bool,
  tristate: _propTypes2.default.bool,
  value: _propTypes2.default.any,
  onCommit: _propTypes2.default.func,
  onClick: _propTypes2.default.func
};

class CheckboxInput extends _react.Component {
  constructor() {
    super();

    this.handleChange = this.handleChange.bind(this);
  }

  handleChange() {
    var _props = this.props;
    const tristate = _props.tristate,
          value = _props.value,
          onCommit = _props.onCommit;


    if (onCommit) {
      let newValue;

      if (tristate) {
        if (value === false) {
          // Unchecked goes to checked.

          newValue = true;
        } else {
          // Checked and indeterminate go to false.

          newValue = false;
        }
      } else {
        newValue = !value;
      }

      onCommit((0, _pathHelpers.getPath)(this.props), newValue);
    }
  }

  render() {
    var _props2 = this.props;

    const className = _props2.className,
          embedded = _props2.embedded,
          readOnly = _props2.readOnly,
          tristate = _props2.tristate,
          value = _props2.value,
          onClick = _props2.onClick,
          name = _props2.name,
          parentPath = _props2.parentPath,
          subpath = _props2.subpath,
          onCommit = _props2.onCommit,
          remainingProps = _objectWithoutProperties(_props2, ['className', 'embedded', 'readOnly', 'tristate', 'value', 'onClick', 'name', 'parentPath', 'subpath', 'onCommit']);

    let checked;

    let classes = (0, _classnames2.default)({
      [_CheckboxInput2.default.readOnly]: readOnly,
      [_CheckboxInput2.default.normal]: !readOnly,
      [_CheckboxInput2.default.embedded]: embedded
    }, className);

    if (tristate) {
      if (value === true) {
        checked = true;
      } else if (value === false) {
        checked = false;
      } else {
        checked = false;
        classes = (0, _classnames2.default)(classes, _CheckboxInput2.default.indeterminate);
      }
    } else {
      checked = !!value;
    }

    // FIXME: Don't break these lint rules.

    /* eslint-disable jsx-a11y/label-has-for, jsx-a11y/no-static-element-interactions */
    return _react2.default.createElement(
      'label',
      { className: classes, onClick: onClick },
      _react2.default.createElement('input', _extends({
        checked: checked,
        disabled: readOnly,
        name: name,
        type: 'checkbox',
        onChange: this.handleChange
      }, remainingProps)),
      _react2.default.createElement('span', null)
    );
    /* eslint-enable jsx-a11y/label-has-for, jsx-a11y/no-static-element-interactions */
  }
}

exports.default = CheckboxInput;
CheckboxInput.propTypes = propTypes;