'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };
/* eslint-disable import/imports-first, import/no-unresolved */

/* eslint-enable import/imports-first, import/no-unresolved */

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactCalendar = require('react-calendar');

var _reactCalendar2 = _interopRequireDefault(_reactCalendar);

var _DropdownInput = require('./DropdownInput');

var _DropdownInput2 = _interopRequireDefault(_DropdownInput);

var _LineInput = require('./LineInput');

var _LineInput2 = _interopRequireDefault(_LineInput);

var _changeable = require('../enhancers/changeable');

var _changeable2 = _interopRequireDefault(_changeable);

var _committable = require('../enhancers/committable');

var _committable2 = _interopRequireDefault(_committable);

var _pathHelpers = require('../helpers/pathHelpers');

var _DateInput = require('../../styles/cspace-input/DateInput.css');

var _DateInput2 = _interopRequireDefault(_DateInput);

require('!style-loader!css-loader!../../styles/react-calendar/calendar.css');

var _dateHelpers = require('../helpers/dateHelpers');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

const DropdownInput = (0, _committable2.default)((0, _changeable2.default)(_DropdownInput2.default));

const propTypes = _extends({}, _DropdownInput2.default.propTypes, {
  locale: _propTypes2.default.string,
  onCommit: _propTypes2.default.func,
  readOnly: _propTypes2.default.bool
});

const defaultProps = {
  locale: 'en-US'
};

class DateInput extends _react.Component {
  constructor(props) {
    super(props);

    this.focusCalendar = this.focusCalendar.bind(this);
    this.handleCalendarChange = this.handleCalendarChange.bind(this);
    this.handleCalendarContainerRef = this.handleCalendarContainerRef.bind(this);
    // this.handleCalendarRef = this.handleCalendarRef.bind(this);
    this.handleDropdownInputApi = this.handleDropdownInputApi.bind(this);
    this.handleDropdownInputBeforeClose = this.handleDropdownInputBeforeClose.bind(this);
    this.handleDropdownInputChange = this.handleDropdownInputChange.bind(this);
    this.handleDropdownInputClose = this.handleDropdownInputClose.bind(this);
    this.handleDropdownInputKeyDown = this.handleDropdownInputKeyDown.bind(this);
    this.handleDropdownInputMount = this.handleDropdownInputMount.bind(this);
    this.handleDropdownInputOpen = this.handleDropdownInputOpen.bind(this);

    const value = (0, _dateHelpers.normalizeISO8601DateString)(props.value);

    this.state = {
      value,
      date: (0, _dateHelpers.parseNormalizedDate)(value),
      open: false
    };
  }

  componentWillReceiveProps(nextProps) {
    const nextValue = (0, _dateHelpers.normalizeISO8601DateString)(nextProps.value);

    this.setState({
      value: nextValue,
      date: (0, _dateHelpers.parseNormalizedDate)(nextValue)
    });
  }

  commit(date) {
    const onCommit = this.props.onCommit;
    const initialValue = this.props.value;


    const normalizedInitialValue = (0, _dateHelpers.normalizeISO8601DateString)(initialValue);
    const nextValue = (0, _dateHelpers.formatDate)(date);

    if (onCommit && (nextValue || normalizedInitialValue) && nextValue !== normalizedInitialValue) {
      onCommit((0, _pathHelpers.getPath)(this.props), nextValue);
    }
  }

  focusCalendar() {
    // TODO: react-calendar v6 no longer has the focus method. Maybe it will come back?

    // if (this.calendar) {
    //   this.calendar.focus();
    // }

    // For now do a bit of a DOM hack to focus.

    if (this.calendarContainerDomNode) {
      const button = this.calendarContainerDomNode.querySelector('button');

      if (button) {
        button.focus();
      }
    }
  }

  handleCalendarChange(date) {
    this.setState({
      value: (0, _dateHelpers.formatDate)(date),
      open: false
    });

    this.commit(date);
    this.focusInput();
  }

  // handleCalendarRef(ref) {
  //   this.calendar = ref;
  // }

  handleCalendarContainerRef(ref) {
    this.calendarContainerDomNode = ref;
  }

  handleDropdownInputApi(api) {
    this.dropdownInputApi = api;
  }

  handleDropdownInputBeforeClose(isCancelled) {
    if (isCancelled) {
      this.setState({
        provisionalDate: undefined,
        value: (0, _dateHelpers.normalizeISO8601DateString)(this.props.value)
      });
    }
  }

  handleDropdownInputChange(value) {
    const date = (0, _dateHelpers.parseNormalizedDate)((0, _dateHelpers.normalizeDateString)(value, this.props.locale));

    this.setState({
      value,
      provisionalDate: date,
      open: true
    });
  }

  handleDropdownInputClose() {
    const nextState = {
      provisionalDate: undefined,
      open: false
    };

    var _state = this.state;
    const provisionalDate = _state.provisionalDate,
          value = _state.value;


    if (typeof provisionalDate !== 'undefined' && value === '') {
      // Normally enter must be pressed on the provisional value in order to select a matching
      // date, but make an exception for the blank value. This allows fields to be cleared
      // without ever pressing enter. This is required by DRYD-227.

      nextState.value = '';

      const onCommit = this.props.onCommit;


      if (onCommit) {
        onCommit((0, _pathHelpers.getPath)(this.props), '');
      }
    } else {
      nextState.value = (0, _dateHelpers.normalizeISO8601DateString)(this.props.value);
    }

    this.setState(nextState);
  }

  handleDropdownInputKeyDown(event) {
    var _state2 = this.state;
    const provisionalDate = _state2.provisionalDate,
          value = _state2.value;


    if (event.key === 'Tab') {
      // DRYD-264: Close the dropdown when tab is depressed. The calendar is still keyboard
      // accessible by pressing down arrow. Need to close immediately (synchronously) -- otherwise
      // the calendar will receive focus before closing, leaving nothing focused. To do this, the
      // close() method of the dropdown needs to be called, rather than just passing open={false}
      // as a prop.

      this.dropdownInputApi.close();

      this.setState({
        open: false
      });
    } else if (typeof provisionalDate !== 'undefined' && event.key === 'Enter') {
      event.preventDefault();

      if (provisionalDate !== null || value === '') {
        this.setState({
          open: false
        });

        this.commit(provisionalDate);
      }
    }
  }

  handleDropdownInputMount({ focusInput }) {
    this.focusInput = focusInput;
  }

  handleDropdownInputOpen() {
    if (!this.state.open) {
      this.setState({
        open: true,
        provisionalDate: undefined
      });
    }
  }

  render() {
    var _props = this.props;

    const locale = _props.locale,
          readOnly = _props.readOnly,
          remainingProps = _objectWithoutProperties(_props, ['locale', 'readOnly']);

    var _state3 = this.state;
    const open = _state3.open,
          date = _state3.date,
          provisionalDate = _state3.provisionalDate,
          value = _state3.value;


    if (readOnly) {
      return _react2.default.createElement(_LineInput2.default, { readOnly: true, value: value, embedded: this.props.embedded });
    }

    let calendarValue;

    if (value) {
      calendarValue = typeof provisionalDate !== 'undefined' ? provisionalDate : date;
    }

    const className = typeof provisionalDate !== 'undefined' ? _DateInput2.default.provisional : _DateInput2.default.normal;

    return _react2.default.createElement(
      DropdownInput,
      _extends({}, remainingProps, {
        className: className,
        focusPopup: this.focusCalendar,
        open: open,
        value: value,
        api: this.handleDropdownInputApi,
        onChange: this.handleDropdownInputChange,
        onBeforeClose: this.handleDropdownInputBeforeClose,
        onClose: this.handleDropdownInputClose,
        onKeyDown: this.handleDropdownInputKeyDown,
        onMount: this.handleDropdownInputMount,
        onOpen: this.handleDropdownInputOpen
      }),
      _react2.default.createElement(
        'div',
        { ref: this.handleCalendarContainerRef },
        _react2.default.createElement(_reactCalendar2.default, {
          locale: locale
          // ref={this.handleCalendarRef}
          , value: calendarValue,
          onChange: this.handleCalendarChange
        })
      )
    );
  }
}

exports.default = DateInput;
DateInput.propTypes = propTypes;
DateInput.defaultProps = defaultProps;