'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = InputTableRow;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _inputHelpers = require('../helpers/inputHelpers');

var _InputTableRow = require('../../styles/cspace-input/InputTableRow.css');

var _InputTableRow2 = _interopRequireDefault(_InputTableRow);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const propTypes = {
  children: _propTypes2.default.node,
  embedded: _propTypes2.default.bool
};

function InputTableRow(props) {
  const children = props.children,
        embedded = props.embedded;


  const inputs = (0, _inputHelpers.extractInputs)(children);

  const modifiedInputs = inputs.map(input => _react2.default.cloneElement(input, {
    label: undefined,
    embedded: true
  }));

  const inputContainers = modifiedInputs.map(input => {
    const flex = input.props.flex;


    const style = flex ? { flex } : undefined;

    return _react2.default.createElement(
      'div',
      { key: input.props.name, style: style },
      input
    );
  });

  const className = embedded ? _InputTableRow2.default.embedded : _InputTableRow2.default.normal;

  return _react2.default.createElement(
    'div',
    { className: className },
    inputContainers
  );
}

InputTableRow.propTypes = propTypes;