'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = Label;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Label = require('../../styles/cspace-input/Label.css');

var _Label2 = _interopRequireDefault(_Label);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const propTypes = {
  children: _propTypes2.default.node,
  readOnly: _propTypes2.default.bool,
  required: _propTypes2.default.bool
};

/**
 * A label for an input.
 */
function Label(props) {
  const children = props.children,
        readOnly = props.readOnly,
        required = props.required;


  const className = required && !readOnly ? _Label2.default.required : _Label2.default.common;

  // FIXME: Set the htmlFor prop to associate the labeled control.

  return (
    /* eslint-disable jsx-a11y/label-has-for */
    _react2.default.createElement(
      'label',
      { className: className },
      children
    )
    /* eslint-enable jsx-a11y/label-has-for */

  );
}

Label.propTypes = propTypes;