'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.default = MiniButton;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _MiniButton = require('../../styles/cspace-input/MiniButton.css');

var _MiniButton2 = _interopRequireDefault(_MiniButton);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

const propTypes = {
  autoWidth: _propTypes2.default.bool,
  className: _propTypes2.default.string,
  readOnly: _propTypes2.default.bool,
  children: _propTypes2.default.node
};

/**
 * A small button attached to an input.
 */
function MiniButton(props) {
  const autoWidth = props.autoWidth,
        className = props.className,
        readOnly = props.readOnly,
        remainingProps = _objectWithoutProperties(props, ['autoWidth', 'className', 'readOnly']);

  const classes = (0, _classnames2.default)(autoWidth ? _MiniButton2.default.autoWidth : _MiniButton2.default.normal, className);

  if (readOnly) {
    return _react2.default.createElement(
      'div',
      { className: classes },
      props.children
    );
  }

  return _react2.default.createElement('button', _extends({}, remainingProps, {
    className: classes,
    type: 'button'
  }));
}

MiniButton.propTypes = propTypes;