'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _pathHelpers = require('../helpers/pathHelpers');

var _LineInput = require('../../styles/cspace-input/LineInput.css');

var _LineInput2 = _interopRequireDefault(_LineInput);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

const propTypes = {
  name: _propTypes2.default.string,
  parentPath: _pathHelpers.pathPropType,
  subpath: _pathHelpers.pathPropType,
  value: _propTypes2.default.string,
  readOnly: _propTypes2.default.bool,
  api: _propTypes2.default.func
};

const defaultProps = {
  value: ''
};

class PasswordInput extends _react.Component {
  constructor() {
    super();

    this.handleRef = this.handleRef.bind(this);
  }

  componentDidMount() {
    const api = this.props.api;


    if (api) {
      api({
        focus: this.focus.bind(this)
      });
    }
  }

  componentWillUnmount() {
    const api = this.props.api;


    if (api) {
      api(null);
    }
  }

  focus() {
    this.domNode.focus();
  }

  handleRef(ref) {
    this.domNode = ref;
  }

  render() {
    var _props = this.props;

    const name = _props.name,
          readOnly = _props.readOnly,
          value = _props.value,
          parentPath = _props.parentPath,
          subpath = _props.subpath,
          api = _props.api,
          remainingProps = _objectWithoutProperties(_props, ['name', 'readOnly', 'value', 'parentPath', 'subpath', 'api']);

    const normalizedValue = value === null || typeof value === 'undefined' ? '' : value;

    return _react2.default.createElement('input', _extends({}, remainingProps, {
      className: _LineInput2.default.normal,
      disabled: readOnly,
      name: name,
      readOnly: !remainingProps.onChange,
      ref: this.handleRef,
      type: 'password',
      value: normalizedValue
    }));
  }
}

exports.default = PasswordInput;
PasswordInput.propTypes = propTypes;
PasswordInput.defaultProps = defaultProps;