'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _FilteringDropdownMenuInput = require('./FilteringDropdownMenuInput');

var _FilteringDropdownMenuInput2 = _interopRequireDefault(_FilteringDropdownMenuInput);

var _optionHelpers = require('../helpers/optionHelpers');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

const propTypes = _FilteringDropdownMenuInput2.default.propTypes;

class PrefixFilteringDropdownMenuInput extends _react.Component {
  constructor(props) {
    super(props);

    this.filter = this.filter.bind(this);
    this.handleDropdownInputCommit = this.handleDropdownInputCommit.bind(this);

    const prefix = null;

    this.state = {
      prefix,
      filteredOptions: (0, _optionHelpers.filterOptionsByPrefix)(props.options, prefix),
      value: props.value
    };
  }

  componentWillReceiveProps(nextProps) {
    this.setState({
      filteredOptions: (0, _optionHelpers.filterOptionsByPrefix)(nextProps.options, this.state.prefix),
      value: nextProps.value
    });
  }

  filter(prefix) {
    this.setState({
      prefix,
      filteredOptions: (0, _optionHelpers.filterOptionsByPrefix)(this.props.options, prefix)
    });
  }

  handleDropdownInputCommit(path, value) {
    const prefix = null;

    this.setState({
      prefix,
      value,
      filteredOptions: (0, _optionHelpers.filterOptionsByPrefix)(this.props.options, prefix)
    });

    const onCommit = this.props.onCommit;


    if (onCommit) {
      onCommit(path, value);
    }
  }

  render() {
    var _props = this.props;

    const options = _props.options,
          remainingProps = _objectWithoutProperties(_props, ['options']);

    var _state = this.state;
    const filteredOptions = _state.filteredOptions,
          value = _state.value;


    return _react2.default.createElement(_FilteringDropdownMenuInput2.default, _extends({}, remainingProps, {
      filter: this.filter,
      options: filteredOptions,
      value: value,
      onCommit: this.handleDropdownInputCommit
    }));
  }
}

exports.default = PrefixFilteringDropdownMenuInput;
PrefixFilteringDropdownMenuInput.propTypes = propTypes;