'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = ReadOnlyInput;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _pathHelpers = require('../helpers/pathHelpers');

var _ReadOnlyInput = require('../../styles/cspace-input/ReadOnlyInput.css');

var _ReadOnlyInput2 = _interopRequireDefault(_ReadOnlyInput);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const propTypes = {
  name: _propTypes2.default.string,
  parentPath: _pathHelpers.pathPropType, // eslint-disable-line react/no-unused-prop-types
  subpath: _pathHelpers.pathPropType, // eslint-disable-line react/no-unused-prop-types
  value: _propTypes2.default.string,
  embedded: _propTypes2.default.bool,
  multiline: _propTypes2.default.bool,
  formatValue: _propTypes2.default.func
};

// Preservation of whitespace is a functional requirement of this component, so this style is
// attached to the DOM to prevent it from being overridden.

const preserveWhiteSpace = {
  whiteSpace: 'pre'
};

/**
 * An input that displays a value, but does not allow it to be edited.
 */
function ReadOnlyInput(props) {
  const name = props.name,
        value = props.value,
        embedded = props.embedded,
        multiline = props.multiline,
        formatValue = props.formatValue;


  const classes = (0, _classnames2.default)(embedded ? _ReadOnlyInput2.default.embedded : _ReadOnlyInput2.default.normal, multiline ? _ReadOnlyInput2.default.multiline : _ReadOnlyInput2.default.oneline);

  return _react2.default.createElement(
    'div',
    {
      className: classes,
      'data-name': name,
      style: preserveWhiteSpace
    },
    formatValue ? formatValue(value) : value
  );
}

ReadOnlyInput.propTypes = propTypes;