'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _CustomCompoundInput = require('./CustomCompoundInput');

var _CustomCompoundInput2 = _interopRequireDefault(_CustomCompoundInput);

var _InputTableRow = require('./InputTableRow');

var _InputTableRow2 = _interopRequireDefault(_InputTableRow);

var _InputTableHeader = require('./InputTableHeader');

var _InputTableHeader2 = _interopRequireDefault(_InputTableHeader);

var _labelable = require('../enhancers/labelable');

var _labelable2 = _interopRequireDefault(_labelable);

var _repeatable = require('../enhancers/repeatable');

var _repeatable2 = _interopRequireDefault(_repeatable);

var _pathHelpers = require('../helpers/pathHelpers');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

const BaseComponent = (0, _repeatable2.default)((0, _labelable2.default)(_CustomCompoundInput2.default));

const propTypes = _extends({}, BaseComponent.propTypes, {
  children: _propTypes2.default.node,
  repeating: _propTypes2.default.bool,
  sortableFields: _propTypes2.default.object,
  onSortInstances: _propTypes2.default.func,
  renderChildInputLabel: _propTypes2.default.func
});

class TabularCompoundInput extends _react.Component {
  constructor() {
    super();

    this.handleSortButtonClick = this.handleSortButtonClick.bind(this);
  }

  handleSortButtonClick(event) {
    const onSortInstances = this.props.onSortInstances;


    if (onSortInstances) {
      onSortInstances((0, _pathHelpers.getPath)(this.props), event.currentTarget.name);
    }
  }

  render() {
    var _props = this.props;

    const children = _props.children,
          repeating = _props.repeating,
          renderChildInputLabel = _props.renderChildInputLabel,
          sortableFields = _props.sortableFields,
          remainingProps = _objectWithoutProperties(_props, ['children', 'repeating', 'renderChildInputLabel', 'sortableFields']);

    const tableHeader = _react2.default.createElement(
      _InputTableHeader2.default,
      {
        embedded: repeating,
        renderLabel: renderChildInputLabel,
        sortableFields: sortableFields,
        onSortButtonClick: this.handleSortButtonClick
      },
      children
    );

    return _react2.default.createElement(
      BaseComponent,
      _extends({}, remainingProps, {
        label: tableHeader,
        repeating: repeating
      }),
      _react2.default.createElement(
        _InputTableRow2.default,
        { embedded: repeating },
        children
      )
    );
  }
}

exports.default = TabularCompoundInput;
TabularCompoundInput.propTypes = propTypes;