'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _cspaceRefname = require('cspace-refname');

var _SubstringFilteringDropdownMenuInput = require('./SubstringFilteringDropdownMenuInput');

var _SubstringFilteringDropdownMenuInput2 = _interopRequireDefault(_SubstringFilteringDropdownMenuInput);

var _withNormalizedOptions = require('../enhancers/withNormalizedOptions');

var _withNormalizedOptions2 = _interopRequireDefault(_withNormalizedOptions);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

const BaseDropdownMenuInput = (0, _withNormalizedOptions2.default)(_SubstringFilteringDropdownMenuInput2.default);

const propTypes = _extends({}, _SubstringFilteringDropdownMenuInput2.default.propTypes, {
  terms: _propTypes2.default.arrayOf(_propTypes2.default.shape({
    refName: _propTypes2.default.string,
    displayName: _propTypes2.default.string
  })),
  onMount: _propTypes2.default.func
});

class TermPickerInput extends _react.Component {
  componentDidMount() {
    const onMount = this.props.onMount;


    if (onMount) {
      onMount();
    }
  }

  render() {
    var _props = this.props;

    const terms = _props.terms,
          value = _props.value,
          onMount = _props.onMount,
          remainingProps = _objectWithoutProperties(_props, ['terms', 'value', 'onMount']);

    let options;

    if (terms) {
      options = terms.map(term => {
        const option = {
          value: term.refName,
          label: term.displayName
        };

        if (term.termStatus === 'inactive') {
          option.disabled = true;
        }

        return option;
      });
    } else {
      options = [];
    }

    return _react2.default.createElement(BaseDropdownMenuInput, _extends({
      options: options,
      value: value,
      valueLabel: (0, _cspaceRefname.getDisplayName)(value)
    }, remainingProps));
  }
}

exports.default = TermPickerInput;
TermPickerInput.propTypes = propTypes;