'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.extractInputs = exports.isInput = undefined;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const isInput = exports.isInput = component => {
  if (!component) {
    return false;
  }

  const type = component.type;

  if (!type) {
    return false;
  }

  const propTypes = type.propTypes;

  if (!propTypes) {
    return false;
  }

  return 'name' in propTypes && 'value' in propTypes && 'parentPath' in propTypes && 'subpath' in propTypes;
};

const extractInputs = exports.extractInputs = children => {
  const inputs = [];

  _react2.default.Children.forEach(children, child => {
    if (isInput(child)) {
      inputs.push(child);
    } else {
      Array.prototype.push.apply(inputs, extractInputs(child.props.children));
    }
  });

  return inputs;
};